function  [vec ]  = mtx2vec(mtx );

%
%MTX2VEC Matrix to Column Vector
%
%MTX2VEC converts a matrix, mtx = [A B C ...],
%where A, B, C, ... are 1 column vectors, 
%to a vector, VEC = [A ; B ; C : ...].

%The conversion is performed in column-oriented method.

%See also VEC2MTX


%------------------------
% dimension of matrix
%------------------------

[m,n] = size(mtx);
vec = [];

for column = 1 : n       
   vec = [vec;mtx(:,column)];
end
return